package com.hotwj.platform.reportStatistics.service;

import com.hotwj.platform.reportStatistics.domain.bo.SysReportTemplateBo;
import com.hotwj.platform.reportStatistics.domain.vo.SysReportTemplateVo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;

import java.util.Collection;
import java.util.List;

/**
 * 报表模板Service接口
 *
 * @author shihongwei
 * @date 2024-03-15
 */
public interface ISysReportTemplateService {

    /**
     * 查询报表模板
     */
    SysReportTemplateVo queryById(Long id);

    /**
     * 查询报表模板
     */
    SysReportTemplateVo queryByCode(String code);

    /**
     * 查询报表模板列表
     */
    TableDataInfo<SysReportTemplateVo> queryPageList(SysReportTemplateBo bo, PageQuery pageQuery);

    /**
     * 查询报表模板列表
     */
    List<SysReportTemplateVo> queryList(SysReportTemplateBo bo);

    /**
     * 新增报表模板
     */
    Boolean insertByBo(SysReportTemplateBo bo);

    /**
     * 修改报表模板
     */
    Boolean updateByBo(SysReportTemplateBo bo);

    /**
     * 校验并批量删除报表模板信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 同步 Classpath 下的模版到数据库
     */
    void syncTemplatesFromClasspath();

    /**
     * 根据模板编码查找对应的 Provider
     */
    IReportDataProvider findProviderByTemplateCode(String templateCode);
}
